/*
Script OP: tP_Atan2

Author: Marc Auvigne (marc.auvigne@outlook.com)
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
This script is provided as is...

How to install : copy paste the script inside <3dsMAX root>\scripts\startup folder, restart 3dsMAX, done!

The script implement ATan2(B,A) for tP since Atan2 is not avalaible via math helper or 3dsMAX expression technique...
It support Degreee or Radian return.

V1.00:
-initial Release
*/

tp_unregister tP_Atan2
plugin  Geometry tP_Atan2
name:"ATan2(B,A)"
category:"matP_Trigonometry" 
classid:#(0x59dad1a8, 0x61c35495) 
extends:TP_ScriptBase
invisible:true
replaceui:true
version:1

(
	--local noVars
			local C_Ouput --output value
	
	--Params
	parameters main rollout:params
	(
		rdo_Type type:#integer ui:rdo_Type default:1
	)
	--RLT
		--Main Rollout
			rollout params "OUTPUT parameters" width:162 height:57
			(
				radiobuttons 'rdo_Type' "Output as: " pos:[17,7] width:99 height:30 labels:#("deg.", "rad.") default:1 columns:2 align:#left
			)
			
		--About RLT
			rollout aboutRlt "About" width:160 height:120
			(
				label 'lbl_Dash' "-----------------------------" pos:[34,5] width:94 height:16 align:#left
				label 'lbl_name' "Marc Auvigne" pos:[47,18] width:67 height:14 align:#left
				label 'lbl_mail' "marc.auvigne at gmail dot com" pos:[7,37] width:147 height:16 align:#left
				label 'lbl_NoWarr' "NO WARRANTY is provided." pos:[12,70] width:137 height:16 enabled:true align:#left
				label 'lbl_UseR' "Use at your own risk." pos:[29,88] width:104 height:16 align:#left
			)
	
	fn tp_color_type =
	(
		2  -- 0 :CONDITION / 1: OPERATOR / 2: HELPER / 3: GENERATOR / 4: INITIATOR / 5: SHAPE
	)

	fn tp_init_inoutputs tp_inout =
	(
		ver = tp_inout.Version()

		if ver == 0 then
		(
			--INPUT
			tp_inout.AddInput	#TP_PORT_TYPE_FLOAT    	"A"		#TP_PORT_FLAG_NEEDED	--0
			tp_inout.AddInput	#TP_PORT_TYPE_FLOAT    	"B"		#TP_PORT_FLAG_NEEDED	--1
			--OUPUT
			tp_inout.AddOutput	#TP_PORT_TYPE_FLOAT    	"Atan2(B,A)"		#TP_PORT_FLAG_NONE
			--SetVers
			tp_inout.SetVersion 1
		)
		else
		(
		)
		--
	)	

	fn tp_calculate tp_outid tp_inout tp_system =
	(
		if tp_outid >= 0 then 
		(
			local A_input = tp_inout.GetInValue 0
			local B_input = tp_inout.GetInValue 1
			local C_ouput = undefined
			
			if ((A_input != undefined) and (B_input != undefined)) then
				(
					If (rdo_Type==1) then --if degree
					(
						C_ouput = Atan2 (B_input) (A_input)
					)
					else --if in as radian
					(
						C_ouput = degtoRad(Atan2 (B_input) (A_input))
					)
					C_ouput
				)
				else
				(
					undefined
				)
			
			
		)
		else(undefined)
	)--End Fn tP_Calculate()
)
tp_register tP_Atan2 2 --register the plugin,  / 0 condition, 1 operator, 2 helper
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------------